"""
	Programmer:	Keith G. Nemitz
	E-mail:		keithn@mousechief.com

	Copyright 2009 Keith G. Nemitz

	Version 0.0.1 Development

A micro sample application for the purpose of demonstrating the most critical elements of the FnF engine.

"""

#Main contains the setup and exit code for the game.

import sys
import os

sys.path += ['.'];


from ctypes import util
#import OpenGL
#OpenGL.ERROR_CHECKING = False;


import pygame
from pygame.locals import *
import pygl2d

import faceEngn

import startupFaces
import saveGame


#---------------------------
#----------- main ----------
#---------------------------

def main(args):
    try:
        gamemain(args)
    except KeyboardInterrupt:
        print 'Keyboard Interrupt (Control-C)...'
        print 'Exiting'


def gamemain(args):
    #make sure we're in the correct directory
    fullpath = os.path.abspath(sys.argv[0])
    dir = os.path.split(fullpath)[0]
    #change the directory to this file
    os.chdir(dir)

    saveGame.restrictSave = True;
    saveGame.InitSettings();

    pygame.mixer.pre_init(22050,-16,2,2048);
    
    #if (False):  #FORCE FULLSCREEN
    if (saveGame.settings.windowed):
        pygl2d.window.init([1024, 768],"7 Grand Steps, by Mousechief Co.")
    else:
        pygl2d.window.init([1024, 768],"Mousechief Co.",flags=DOUBLEBUF|FULLSCREEN)

    #StartFaceEngine
    faceEngn.InitFnF(pygl2d.window);
    faceEngn.RunFaces(startupFaces.FirstFace());

    #game is finished at this point, do any
    #uninitialization needed
    pass


# import features, faces, ftrePicts, fnfEvents, ftreStrs
# class FirstFace(faces.Face):
#     
#     def TransitionIn(self):
#         features.AddColorRect(self,(0,0,0,255), 0, 0, 1024, 768);
#         ftreStrs.AddDynStr(self,"Hello operator.",370,400);
#         ftrePicts.AddPict(self,"wedge.png",300,300, opac=150);
#         pass
# 
#     def TransitionOut(self):
#         self.ClearFace();
#         pass
#     
#     def Core(self):
#         fnfEvents.PumpEvents(self)
#         return 0;


main ([])

os._exit(0)